
using System;
using System.Text;

namespace LeeTM.src
{
    class ArrayList_atomic
    {
        private class ListNode
        {
            public object obj = null;
            public ListNode next = null;
        }

        private ListNode head = null;
        private ListNode last = null;
        private int count = 0;

        public ArrayList_atomic()
        {
            head = new ListNode();
            last = new ListNode();
            head.next = last;
        }

        public int Count
        {
            get
            {
                return count;
            }
        }

        public object Get(int index)
        {
            if (index < 0 || index >= count)
                return null;
            ListNode curr = head;
            for (int i = 0; i <= index; i++)
            {
                curr = curr.next;
            }
            return curr.obj;
        }

        public void Add(object obj)
        {
            ListNode curr = head;
            while (curr.next != last)
                curr = curr.next;
            ListNode newNode = new ListNode();
            newNode.obj = obj;
            curr.next = newNode;
            newNode.next = last;
            this.count++;
        }

        public void RemoveAt(int index)
        {
            if (index < 0 || index >= count)
                return;
            ListNode curr = head;
            for (int i = 0; i < index; i++)
            {
                curr = curr.next;
            }
            curr.next = curr.next.next;
            this.count--;
        }
    }
}
