﻿using System;

public class RowMajorIntArray
{
    private int[] array;
    private readonly int xsize = 0;
    private readonly int ysize = 0;
    private readonly int zsize = 0;

    public RowMajorIntArray(int x, int y, int z)
    {
        this.xsize = x;
        this.ysize = y;
        this.zsize = z;
        this.array =  new int[x * y * z];
    }

    public int this[int x, int y, int z]
    {
        get { return this.array[((x * ysize) + y) * zsize + z]; }
        set { this.array[((x * ysize) + y) * zsize + z] = value; }
    }
}
