﻿using System;

public class GridCellArray
{
    private GridCell[] array;
    private readonly int xsize = 0;
    private readonly int ysize = 0;
    private readonly int zsize = 0;

    public GridCellArray(int x, int y, int z)
    {
        this.xsize = x;
        this.ysize = y;
        this.zsize = z;
        this.array = new GridCell[x * y * z];
    }

    public GridCell this[int x, int y, int z]
    {
        get { return this.array[((x * ysize) + y) * zsize + z]; }
        set { this.array[((x * ysize) + y) * zsize + z] = value; }
    }
}
